<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<meta charset="utf-8" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="generator" content="pandoc" />


<meta name="author" content="Monica Abrudan" />


<title>Refining data</title>

<script src="site_libs/jquery-1.11.3/jquery.min.js"></script>
<meta name="viewport" content="width=device-width, initial-scale=1" />
<link href="site_libs/bootstrap-3.3.5/css/bootstrap.min.css" rel="stylesheet" />
<script src="site_libs/bootstrap-3.3.5/js/bootstrap.min.js"></script>
<script src="site_libs/bootstrap-3.3.5/shim/html5shiv.min.js"></script>
<script src="site_libs/bootstrap-3.3.5/shim/respond.min.js"></script>
<script src="site_libs/navigation-1.1/tabsets.js"></script>
<link href="site_libs/highlightjs-9.12.0/default.css" rel="stylesheet" />
<script src="site_libs/highlightjs-9.12.0/highlight.js"></script>

<style type="text/css">code{white-space: pre;}</style>
<style type="text/css">
  pre:not([class]) {
    background-color: white;
  }
</style>
<script type="text/javascript">
if (window.hljs) {
  hljs.configure({languages: []});
  hljs.initHighlightingOnLoad();
  if (document.readyState && document.readyState === "complete") {
    window.setTimeout(function() { hljs.initHighlighting(); }, 0);
  }
}
</script>



<style type="text/css">
h1 {
  font-size: 34px;
}
h1.title {
  font-size: 38px;
}
h2 {
  font-size: 30px;
}
h3 {
  font-size: 24px;
}
h4 {
  font-size: 18px;
}
h5 {
  font-size: 16px;
}
h6 {
  font-size: 12px;
}
.table th:not([align]) {
  text-align: left;
}
</style>




<style type = "text/css">
.main-container {
  max-width: 940px;
  margin-left: auto;
  margin-right: auto;
}
code {
  color: inherit;
  background-color: rgba(0, 0, 0, 0.04);
}
img {
  max-width:100%;
  height: auto;
}
.tabbed-pane {
  padding-top: 12px;
}
.html-widget {
  margin-bottom: 20px;
}
button.code-folding-btn:focus {
  outline: none;
}
summary {
  display: list-item;
}
</style>


<style type="text/css">
/* padding for bootstrap navbar */
body {
  padding-top: 51px;
  padding-bottom: 40px;
}
/* offset scroll position for anchor links (for fixed navbar)  */
.section h1 {
  padding-top: 56px;
  margin-top: -56px;
}
.section h2 {
  padding-top: 56px;
  margin-top: -56px;
}
.section h3 {
  padding-top: 56px;
  margin-top: -56px;
}
.section h4 {
  padding-top: 56px;
  margin-top: -56px;
}
.section h5 {
  padding-top: 56px;
  margin-top: -56px;
}
.section h6 {
  padding-top: 56px;
  margin-top: -56px;
}
.dropdown-submenu {
  position: relative;
}
.dropdown-submenu>.dropdown-menu {
  top: 0;
  left: 100%;
  margin-top: -6px;
  margin-left: -1px;
  border-radius: 0 6px 6px 6px;
}
.dropdown-submenu:hover>.dropdown-menu {
  display: block;
}
.dropdown-submenu>a:after {
  display: block;
  content: " ";
  float: right;
  width: 0;
  height: 0;
  border-color: transparent;
  border-style: solid;
  border-width: 5px 0 5px 5px;
  border-left-color: #cccccc;
  margin-top: 5px;
  margin-right: -10px;
}
.dropdown-submenu:hover>a:after {
  border-left-color: #ffffff;
}
.dropdown-submenu.pull-left {
  float: none;
}
.dropdown-submenu.pull-left>.dropdown-menu {
  left: -100%;
  margin-left: 10px;
  border-radius: 6px 0 6px 6px;
}
</style>

<script>
// manage active state of menu based on current page
$(document).ready(function () {
  // active menu anchor
  href = window.location.pathname
  href = href.substr(href.lastIndexOf('/') + 1)
  if (href === "")
    href = "index.html";
  var menuAnchor = $('a[href="' + href + '"]');

  // mark it active
  menuAnchor.parent().addClass('active');

  // if it's got a parent navbar menu mark it active as well
  menuAnchor.closest('li.dropdown').addClass('active');
});
</script>

<!-- tabsets -->

<style type="text/css">
.tabset-dropdown > .nav-tabs {
  display: inline-table;
  max-height: 500px;
  min-height: 44px;
  overflow-y: auto;
  background: white;
  border: 1px solid #ddd;
  border-radius: 4px;
}

.tabset-dropdown > .nav-tabs > li.active:before {
  content: "";
  font-family: 'Glyphicons Halflings';
  display: inline-block;
  padding: 10px;
  border-right: 1px solid #ddd;
}

.tabset-dropdown > .nav-tabs.nav-tabs-open > li.active:before {
  content: "&#xe258;";
  border: none;
}

.tabset-dropdown > .nav-tabs.nav-tabs-open:before {
  content: "";
  font-family: 'Glyphicons Halflings';
  display: inline-block;
  padding: 10px;
  border-right: 1px solid #ddd;
}

.tabset-dropdown > .nav-tabs > li.active {
  display: block;
}

.tabset-dropdown > .nav-tabs > li > a,
.tabset-dropdown > .nav-tabs > li > a:focus,
.tabset-dropdown > .nav-tabs > li > a:hover {
  border: none;
  display: inline-block;
  border-radius: 4px;
}

.tabset-dropdown > .nav-tabs.nav-tabs-open > li {
  display: block;
  float: none;
}

.tabset-dropdown > .nav-tabs > li {
  display: none;
}
</style>

<script>
$(document).ready(function () {
  window.buildTabsets("TOC");
});

$(document).ready(function () {
  $('.tabset-dropdown > .nav-tabs > li').click(function () {
    $(this).parent().toggleClass('nav-tabs-open')
  });
});
</script>

<!-- code folding -->




</head>

<body>


<div class="container-fluid main-container">




<div class="navbar navbar-default  navbar-fixed-top" role="navigation">
  <div class="container">
    <div class="navbar-header">
      <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar">
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <a class="navbar-brand" href="index.html">R examples</a>
    </div>
    <div id="navbar" class="navbar-collapse collapse">
      <ul class="nav navbar-nav">
        <li>
  <a href="data_joining_2.html">Refining/merging data from Pathogen Watch</a>
</li>
<li>
  <a href="plot_AMR_profiles_per_ST.html">Plot AMR profiles</a>
</li>
<li>
  <a href="data_joining_1.html">Manipulating AMR metadata</a>
</li>
<li>
  <a href="Kpn_concordance_analysis.html">Kpn pathogen watch concordance</a>
</li>
      </ul>
      <ul class="nav navbar-nav navbar-right">
        
      </ul>
    </div><!--/.nav-collapse -->
  </div><!--/.container -->
</div><!--/.navbar -->

<div class="fluid-row" id="header">



<h1 class="title toc-ignore">Refining data</h1>
<h4 class="author">Monica Abrudan</h4>

</div>


<div id="s.-aureus.-merge-epi-metadata-ariba-resistance-ariba-virulence-pathogen.watch-output" class="section level2">
<h2>S. aureus. Merge epi metadata + ARIBA resistance + ARIBA virulence + Pathogen.watch output</h2>
<p>Include libraries</p>
<pre class="r"><code>library(stringr)
library(phytools)</code></pre>
</div>
<div id="format-sample-names." class="section level2">
<h2>Format sample names.</h2>
<pre class="r"><code>change_names &lt;- function(data){
  data[] &lt;- lapply(data, as.character)
  data[,1] &lt;- str_replace(data[,1],&quot;#&quot;,&quot;_&quot;)
  return(data)
}</code></pre>
</div>
<div id="format-cells-that-contain-which-are-likely-to-be-missinterpreted-when-you-read-csv-files-in-microreact." class="section level2">
<h2>Format cells that contain “,”, which are likely to be missinterpreted when you read CSV files in Microreact.</h2>
<pre class="r"><code>change_char &lt;- function(data){
  data[] &lt;- lapply(data, as.character)
  n&lt;-ncol(a)
  for (j in 1:n){
    data[,j] &lt;- str_replace_all(data[,j],&quot;,&quot;,&quot;;&quot;)
  }
  return(data)
}</code></pre>
</div>
<div id="add-custom-colouring-to-resistancevirulence-presenceabsence" class="section level2">
<h2>Add custom colouring to Resistance/Virulence presence/absence</h2>
<pre class="r"><code>colour_table &lt;- function(data){
  for (i in 2:ncol(data)){
    data[,i] &lt;-  str_replace(data[,i],&quot;0&quot;,&quot;absent&quot;)
    data[,i] &lt;-  str_replace(data[,i],&quot;no&quot;,&quot;absent&quot;)
    data[,i] &lt;-  str_replace(data[,i],&quot;1&quot;,&quot;present&quot;)
    data[,i] &lt;-  str_replace(data[,i],&quot;yes&quot;,&quot;present&quot;)
    data[,i] &lt;-  str_replace(data[,i],&quot;NOT_FOUND&quot;,&quot;absent&quot;)
    data[,i] &lt;-  str_replace(data[,i],&quot;RESISTANT&quot;,&quot;present&quot;)
    data[,i] &lt;-  str_replace(data[,i],&quot;INDUCIBLE&quot;,&quot;inducible&quot;)
    
    new_column &lt;- data[,i]
    new_column &lt;- str_replace(new_column,&quot;absent&quot;,&quot;#efefef&quot;)
    new_column &lt;- str_replace(new_column,&quot;present&quot;,&quot;#ff6b6b&quot;)
    new_column &lt;- str_replace(new_column,&quot;inducible&quot;,&quot;#fee11a&quot;)
    name &lt;- paste(colnames(data)[i],&quot;__colour&quot;,sep=&#39;&#39;)
    new_dataframe &lt;- data.frame(name=new_column)
    colnames(new_dataframe)[1] &lt;-name
    data &lt;- cbind(data, new_dataframe)
  }
  return(data)
}</code></pre>
</div>
<div id="set-the-path-to-directory-where-the-data-is-stored" class="section level2">
<h2>Set the path to directory where the data is stored</h2>
<pre class="r"><code>path&lt;-&quot;data/data_joining_2/&quot;</code></pre>
</div>
<div id="read-the-phylogenetic-tree-you-are-using-in-the-microreact-and-the-epidemiological-metadata.-only-select-records-that-are-tips-the-tree." class="section level2">
<h2>Read the phylogenetic tree you are using in the Microreact and the Epidemiological metadata. Only select records that are tips the tree.</h2>
<pre class="r"><code>tree &lt;- read.newick(file=paste(path,&quot;tree.nwk&quot;, sep=&#39;&#39;))
tree_frame &lt;- as.data.frame(tree$tip.label)
colnames(tree_frame)[1] &lt;- &quot;id&quot;
a&lt;- read.csv(file=paste(path,&quot;epi_metadata.csv&quot;, sep=&#39;&#39;))
a &lt;- change_names(a)
a&lt;- change_char(a)
t&lt;- merge(tree_frame, a, by.x=&#39;id&#39; , by.y=&#39;id&#39;, all.x = T, all.y=F)</code></pre>
</div>
<div id="read-the-ariba-output-for-ncbi-resistance-genes-as-produced-by-the-ghru-amr-prediction-pipeline-and-merge-it-with-the-previous-dataset." class="section level2">
<h2>Read the Ariba output for ncbi resistance genes, as produced by the GHRU amr prediction pipeline and merge it with the previous dataset.</h2>
<pre class="r"><code>amr &lt;- read.csv(file=paste(path,&quot;combined_summary.csv&quot;, sep=&#39;&#39;))
amr &lt;- change_names(amr)
amr &lt;- colour_table(amr)
t&lt;- merge(t, amr, by.x=&#39;id&#39; , by.y=&#39;name&#39;, all.x = T, all.y=F)</code></pre>
</div>
<div id="read-the-pathogen.watch-snps.csv-output-and-merge-it-with-the-previous-dataset." class="section level2">
<h2>Read the Pathogen.watch snps.csv output and merge it with the previous dataset.</h2>
<pre class="r"><code>snps&lt;-read.csv(file=paste(path,&quot;snps.csv&quot;, sep=&#39;&#39;))
snps &lt;- change_names(snps)
snps &lt;- colour_table (snps)
t_snps &lt;- merge(t, snps, by.x=&#39;id&#39; , by.y=&#39;NAME&#39;, all.x = T, all.y=F)</code></pre>
</div>
<div id="read-the-pathogen.watch-genes.csv-output-and-merge-it-with-the-previous-dataset." class="section level2">
<h2>Read the Pathogen.watch genes.csv output and merge it with the previous dataset.</h2>
<pre class="r"><code>genes&lt;-read.csv(file=paste(path,&quot;genes.csv&quot;, sep=&#39;&#39;))
genes &lt;- change_names(genes)
genes &lt;- colour_table (genes)
t_snps_genes &lt;- merge(t_snps, genes, by.x=&#39;id&#39; , by.y=&#39;NAME&#39;, all.x = T, all.y=F)</code></pre>
</div>
<div id="read-the-pathogen.watch-profile.csv-output-and-merge-it-with-the-previous-dataset." class="section level2">
<h2>Read the Pathogen.watch profile.csv output and merge it with the previous dataset.</h2>
<pre class="r"><code>profile &lt;- read.csv(file=paste(path,&quot;profile.csv&quot;, sep=&#39;&#39;))
profile &lt;- change_names(profile)
profile &lt;- colour_table (profile)
t_snps_genes_profile &lt;- merge(t_snps_genes, profile, by.x=&#39;id&#39; , by.y=&#39;NAME&#39;, all.x = T, all.y=F)</code></pre>
</div>
<div id="read-the-vfdb_core.csv-output-produced-by-ariba" class="section level2">
<h2>Read the vfdb_core.csv output produced by ARIBA</h2>
<pre class="r"><code>virulence &lt;- read.csv(file=paste(path,&quot;vfdb_core.csv&quot;, sep=&#39;&#39;))
virulence[] &lt;- lapply(virulence, as.character)
colnames(virulence) &lt;- str_replace(colnames(virulence), &quot;.match&quot;, &quot;&quot;)

ant &lt;- strsplit(virulence[,1],&#39;/&#39;)[[1]]
virulence[,1] &lt;- str_replace(ant[length(ant)-2],&quot;#&quot;,&quot;_&quot;)
virulence &lt;- colour_table (virulence)
t_snps_genes_profile_virulence &lt;- merge(t_snps_genes_profile, virulence, by.x=&#39;id&#39; , by.y=&#39;name&#39;, all.x = T, all.y=F)</code></pre>
</div>
<div id="add-a-row-for-the-reference-genome-if-needed-and-then-print-the-metadata-file.-now-you-can-upload-it-to-microreact." class="section level2">
<h2>Add a row for the reference genome, if needed, and then print the metadata file. Now you can upload it to microreact.</h2>
<pre class="r"><code>ref_dataframe &lt;- data.frame(&#39;id&#39; = &#39;***&#39;)
metadata_with_ref &lt;- plyr::rbind.fill(t_snps_genes_profile_virulence, ref_dataframe)
write.csv(metadata_with_ref, file=paste(path,&quot;microreact_metadata.csv&quot;, sep=&#39;&#39;), quote = FALSE, row.names =FALSE)</code></pre>
</div>




</div>

<script>

// add bootstrap table styles to pandoc tables
function bootstrapStylePandocTables() {
  $('tr.header').parent('thead').parent('table').addClass('table table-condensed');
}
$(document).ready(function () {
  bootstrapStylePandocTables();
});


</script>

<!-- dynamically load mathjax for compatibility with self-contained -->
<script>
  (function () {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src  = "https://mathjax.rstudio.com/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML";
    document.getElementsByTagName("head")[0].appendChild(script);
  })();
</script>

</body>
</html>
